/* Main */

#include <iostream>
#include "Number.h"
#include "Rational.h"
#include "Complex.h"

using std::cout;
using std::cin;
using std::endl;


Rational yellowSubRoutine( Rational x ) {
  cout << "NoOfNumbers (YSR): " << Number::noOfNumbers() << endl; 

  if ( !x.isPositive() )
    x = x * Rational( -1 );

  x = Rational( 1, 1 ) / x; 

  return x;
}


int main() {
  Rational a, b( 7 ), c( 4, 3 ), d=c;

  cout << "Value from default numerator and denominator: ";
  a.write();
  cout << endl;

  cout << "Value from default denominator: ";
  b.write();
  cout << endl;

  cout << "Value from constructor call with two parameters: ";
  c.write();
  cout << endl;

  cout << "Value from copy constructor: ";
  d.write();
  cout << endl;
 
  cout << "7 / FourThirds: "; 
  ( b / c ).write(); // same as ( b.operator/(c) ).write
  cout << endl;

  cout << "NoOfNumbers: " << Number::noOfNumbers() << endl;

  Rational input, previous=Rational(0,1), result;
  while ( true )   {
    cout << "Please enter a rational number (exit with '0 1') : " << endl;
    input.read();
   
    if ( input == Rational( 0, 1 ) )
      break; // abort while loop

    result = yellowSubRoutine( input );
    cout << "Positive Inverse: ";
    result.write();
    cout << endl;

    input.write();
    cout << " < ";
    previous.write();
    cout << ": " << (input<previous) << endl;    

    input.write();
    cout << " <= ";
    previous.write();
    cout << ": " << (input<=previous) << endl;    

    input.write();
    cout << " > ";
    previous.write();
    cout << ": " << (input>previous) << endl;    

    input.write();
    cout << " >= ";
    previous.write();
    cout << ": " << (input>=previous) << endl;    

    previous=input;

    cout << "NoOfNumbers: " << Number::noOfNumbers() << endl;
  }

  Complex input_c, previous_c=Complex(0,1), result_c;

  while ( true )  {
    cout << "Please enter a complex number (exit with '0 1') : " << endl;
    input_c.read();
   
    if ( input_c == Complex( 0, 1 ) )
      break; // abort while loop

    input_c.write();
    cout << " == ";
    previous_c.write();
    cout << ": " << (input_c==previous_c) << endl;    

    input_c.write();
    cout << " isReal ";
    cout << ": " << (input_c.isReal()) << endl;    

    input_c.write();
    cout << " getReal ";
    cout << ": " << (input_c.getReal()) << endl;    

    input_c.write();
    cout << " + ";
    previous_c.write();
    cout << ": ";
    (input_c+previous_c).write();
    cout << endl;    

    input_c.write();
    cout << " * ";
    previous_c.write();
    cout << ": ";
    (input_c*previous_c).write();
    cout << endl;    

    previous_c=input_c;

    cout << "NoOfNumbers: " << Number::noOfNumbers() << endl;
  }

  return 0; 
}

